/*
 *  Copyright (c) 2021 NetApp
 *  All rights reserved
 */

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	"time"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
	v1alpha1 "quark.netapp.io/volume-controller/pkg/apis/volumecontroller/v1alpha1"
	scheme "quark.netapp.io/volume-controller/pkg/client/clientset/versioned/scheme"
)

// QuarksGetter has a method to return a QuarkInterface.
// A group's client should implement this interface.
type QuarksGetter interface {
	Quarks(namespace string) QuarkInterface
}

// QuarkInterface has methods to work with Quark resources.
type QuarkInterface interface {
	Create(ctx context.Context, quark *v1alpha1.Quark, opts v1.CreateOptions) (*v1alpha1.Quark, error)
	Update(ctx context.Context, quark *v1alpha1.Quark, opts v1.UpdateOptions) (*v1alpha1.Quark, error)
	UpdateStatus(ctx context.Context, quark *v1alpha1.Quark, opts v1.UpdateOptions) (*v1alpha1.Quark, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.Quark, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.QuarkList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.Quark, err error)
	QuarkExpansion
}

// quarks implements QuarkInterface
type quarks struct {
	client rest.Interface
	ns     string
}

// newQuarks returns a Quarks
func newQuarks(c *QuarkV1alpha1Client, namespace string) *quarks {
	return &quarks{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the quark, and returns the corresponding quark object, and an error if there is any.
func (c *quarks) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.Quark, err error) {
	result = &v1alpha1.Quark{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("quarks").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of Quarks that match those selectors.
func (c *quarks) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.QuarkList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.QuarkList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("quarks").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested quarks.
func (c *quarks) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("quarks").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a quark and creates it.  Returns the server's representation of the quark, and an error, if there is any.
func (c *quarks) Create(ctx context.Context, quark *v1alpha1.Quark, opts v1.CreateOptions) (result *v1alpha1.Quark, err error) {
	result = &v1alpha1.Quark{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("quarks").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(quark).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a quark and updates it. Returns the server's representation of the quark, and an error, if there is any.
func (c *quarks) Update(ctx context.Context, quark *v1alpha1.Quark, opts v1.UpdateOptions) (result *v1alpha1.Quark, err error) {
	result = &v1alpha1.Quark{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("quarks").
		Name(quark.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(quark).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *quarks) UpdateStatus(ctx context.Context, quark *v1alpha1.Quark, opts v1.UpdateOptions) (result *v1alpha1.Quark, err error) {
	result = &v1alpha1.Quark{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("quarks").
		Name(quark.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(quark).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the quark and deletes it. Returns an error if one occurs.
func (c *quarks) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("quarks").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *quarks) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("quarks").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched quark.
func (c *quarks) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.Quark, err error) {
	result = &v1alpha1.Quark{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("quarks").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
