/*
 *  Copyright (c) 2021 NetApp
 *  All rights reserved
 */

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
	v1alpha1 "quark.netapp.io/volume-controller/pkg/apis/volumecontroller/v1alpha1"
)

// NetAppVolumeUsageLister helps list NetAppVolumeUsages.
// All objects returned here must be treated as read-only.
type NetAppVolumeUsageLister interface {
	// List lists all NetAppVolumeUsages in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NetAppVolumeUsage, err error)
	// NetAppVolumeUsages returns an object that can list and get NetAppVolumeUsages.
	NetAppVolumeUsages(namespace string) NetAppVolumeUsageNamespaceLister
	NetAppVolumeUsageListerExpansion
}

// netAppVolumeUsageLister implements the NetAppVolumeUsageLister interface.
type netAppVolumeUsageLister struct {
	indexer cache.Indexer
}

// NewNetAppVolumeUsageLister returns a new NetAppVolumeUsageLister.
func NewNetAppVolumeUsageLister(indexer cache.Indexer) NetAppVolumeUsageLister {
	return &netAppVolumeUsageLister{indexer: indexer}
}

// List lists all NetAppVolumeUsages in the indexer.
func (s *netAppVolumeUsageLister) List(selector labels.Selector) (ret []*v1alpha1.NetAppVolumeUsage, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NetAppVolumeUsage))
	})
	return ret, err
}

// NetAppVolumeUsages returns an object that can list and get NetAppVolumeUsages.
func (s *netAppVolumeUsageLister) NetAppVolumeUsages(namespace string) NetAppVolumeUsageNamespaceLister {
	return netAppVolumeUsageNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// NetAppVolumeUsageNamespaceLister helps list and get NetAppVolumeUsages.
// All objects returned here must be treated as read-only.
type NetAppVolumeUsageNamespaceLister interface {
	// List lists all NetAppVolumeUsages in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NetAppVolumeUsage, err error)
	// Get retrieves the NetAppVolumeUsage from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha1.NetAppVolumeUsage, error)
	NetAppVolumeUsageNamespaceListerExpansion
}

// netAppVolumeUsageNamespaceLister implements the NetAppVolumeUsageNamespaceLister
// interface.
type netAppVolumeUsageNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all NetAppVolumeUsages in the indexer for a given namespace.
func (s netAppVolumeUsageNamespaceLister) List(selector labels.Selector) (ret []*v1alpha1.NetAppVolumeUsage, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NetAppVolumeUsage))
	})
	return ret, err
}

// Get retrieves the NetAppVolumeUsage from the indexer for a given namespace and name.
func (s netAppVolumeUsageNamespaceLister) Get(name string) (*v1alpha1.NetAppVolumeUsage, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("netappvolumeusage"), name)
	}
	return obj.(*v1alpha1.NetAppVolumeUsage), nil
}
